%option main

/*
  Voir :
  http://www.w3.org/Addressing/URL/5_BNF.html
*/


%{
#define AFFICHER(text) (printf("%s\t" text "\n",yytext))
%}

alpha [a-zA-Z]
digit [0-9]
safe  [$\-_@.&+-] 
extra [!*"'(),]
    // " comment here 
hex {digit}|[a-eA-E]
escape %{hex}{hex} 

xalpha    {alpha}|{digit}|{safe}|{extra}|{escape}
xalphas {xalpha}+
xpalpha {xalpha}|\+
xpalphas {xpalpha}+

segment {xpalphas}
path {segment}?(\/{segment})*

port {digit}{1,4}
hostname {digit}{1,3}\.{digit}{1,3}\.{digit}{1,3}\.{digit}{1,3}|{xpalphas}
user {xalphas}
login {user}@{hostname}
hostport {hostname}:{port}?

hhtp "http://"
ftp  "ftp://"
mailto "mailto:"

httpaddress {http}{hostport}(\/{path})?(\?{search})? 
ftpaddress {ftp}{login}\/{path} 
mailtoaddress {mailto}{xalphas}@{hostname} 

%%
{mailto} {AFFICHER("protocole mailto");}
{login} {AFFICHER("un login");}
{user} {AFFICHER("un utilisateur");}
{hostport} {AFFICHER("un hote avec port optionnel");}
{hhtp} {AFFICHER("protocole http");}
{ftp}  {AFFICHER("protocole ftp");}

       /*{hostname} {AFFICHER("un hote");}*/

{path} {AFFICHER("un chemin");}

.|\n {}

%%
